Index: squid/src/client_side.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/client_side.c,v
retrieving revision 1.7.2.12
retrieving revision 1.7.2.13
diff -u -r1.7.2.12 -r1.7.2.13
--- squid/src/client_side.c	1 Jul 2007 08:34:23 -0000	1.7.2.12
+++ squid/src/client_side.c	2 Jul 2007 07:36:53 -0000	1.7.2.13
@@ -1,6 +1,6 @@
 
 /*
- * $Id: client_side.c,v 1.7.2.12 2007/07/01 08:34:23 amosjeffries Exp $
+ * $Id: client_side.c,v 1.7.2.13 2007/07/02 07:36:53 amosjeffries Exp $
  *
  * DEBUG: section 33    Client-side Routines
  * AUTHOR: Duane Wessels
@@ -220,8 +220,8 @@
     request_t *request = http->request;
     request->x_forwarded_for_iterator = httpHeaderGetList(
 	&request->header, HDR_X_FORWARDED_FOR);
-    debug(33, 5) ("clientFollowXForwardedForStart: indirect_client_addr=%s XFF='%s'\n", 
-	sockaddr_ntoa(&request->indirect_client_addr),
+    debug(33, 5) ("clientFollowXForwardedForStart: indirect_client_addr=%s XFF='%s'\n",
+	inet_ntoa(request->indirect_client_addr),
 	strBuf(request->x_forwarded_for_iterator));
     clientFollowXForwardedForNext(http);
 }
@@ -232,7 +232,7 @@
     clientHttpRequest *http = data;
     request_t *request = http->request;
     debug(33, 5) ("clientFollowXForwardedForNext: indirect_client_addr=%s XFF='%s'\n",
-	sockaddr_ntoa(&request->indirect_client_addr),
+	inet_ntoa(request->indirect_client_addr),
 	strBuf(request->x_forwarded_for_iterator));
     if (strLen(request->x_forwarded_for_iterator) != 0) {
 	/* check the acl to see whether to believe the X-Forwarded-For header */
@@ -266,10 +266,9 @@
 	const char *p;
 	const char *asciiaddr;
 	int l;
-	struct addrinfo hints, *res;
-
+	struct in_addr addr;
 	debug(33, 5) ("clientFollowXForwardedForDone: indirect_client_addr=%s is trusted\n",
-	    sockaddr_ntoa(&request->indirect_client_addr));
+	    inet_ntoa(request->indirect_client_addr));
 	p = strBuf(request->x_forwarded_for_iterator);
 	l = strLen(request->x_forwarded_for_iterator);
 
@@ -291,18 +290,16 @@
 	while (l > 0 && !(p[l - 1] == ',' || xisspace(p[l - 1])))
 	    l--;
 	asciiaddr = p + l;
-	memset(&hints, 0, sizeof(hints));
-	if (getaddrinfo(asciiaddr, NULL, &hints, &res)) {
+	if (inet_aton(asciiaddr, &addr) == 0) {
 	    /* the address is not well formed; do not use it */
 	    debug(33, 3) ("clientFollowXForwardedForDone: malformed address '%s'\n",
 		asciiaddr);
 	    goto done;
 	}
-	
 	debug(33, 3) ("clientFollowXForwardedForDone: changing indirect_client_addr from %s to '%s'\n",
-	    sockaddr_ntoa(&request->indirect_client_addr),
+	    inet_ntoa(request->indirect_client_addr),
 	    asciiaddr);
-	xmemcpy(&request->indirect_client_addr, res->ai_addr, SOCKLEN(res->ai_addr)); 
+	request->indirect_client_addr = addr;
 	strCut(request->x_forwarded_for_iterator, l);
 	if (!Config.onoff.acl_uses_indirect_client) {
 	    /*
@@ -315,10 +312,10 @@
 	return;
     } else if (answer == ACCESS_DENIED) {
 	debug(33, 5) ("clientFollowXForwardedForDone: indirect_client_addr=%s not trusted\n",
-	    sockaddr_ntoa(&request->indirect_client_addr));
+	    inet_ntoa(request->indirect_client_addr));
     } else {
 	debug(33, 5) ("clientFollowXForwardedForDone: indirect_client_addr=%s nothing more to do\n",
-	    sockaddr_ntoa(&request->indirect_client_addr));
+	    inet_ntoa(request->indirect_client_addr));
     }
   done:
     /* clean up, and pass control to clientAccessCheck */
@@ -329,10 +326,10 @@
 	 * instead of the direct client.
 	 */
 	ConnStateData *conn = http->conn;
-	xmemcpy(&conn->log_addr, &request->indirect_client_addr, 
-		sizeof(struct sockaddr_storage));
+	conn->log_addr = request->indirect_client_addr;
+	conn->log_addr.s_addr &= Config.Addrs.client_netmask.s_addr;
 	debug(33, 3) ("clientFollowXForwardedForDone: setting log_addr=%s\n",
-	    sockaddr_ntoa(&conn->log_addr));
+	    inet_ntoa(conn->log_addr));
     }
     stringClean(&request->x_forwarded_for_iterator);
     http->acl_checklist = NULL;	/* XXX do we need to aclChecklistFree() ? */
@@ -605,14 +602,12 @@
 	http->uri = xstrdup(urlCanonical(new_request));
 	new_request->http_ver = old_request->http_ver;
 	httpHeaderAppend(&new_request->header, &old_request->header);
-	xmemcpy(&new_request->client_addr, &old_request->client_addr,
-		sizeof(struct sockaddr_storage));
+	new_request->client_addr = old_request->client_addr;
 	new_request->client_port = old_request->client_port;
 #if FOLLOW_X_FORWARDED_FOR
 	new_request->indirect_client_addr = old_request->indirect_client_addr;
 #endif /* FOLLOW_X_FORWARDED_FOR */
-	xmemcpy(&new_request->my_addr, &old_request->my_addr,
-		sizeof(struct sockaddr_storage));
+	new_request->my_addr = old_request->my_addr;
 	new_request->my_port = old_request->my_port;
 	new_request->flags = old_request->flags;
 	new_request->flags.redirected = 1;
@@ -1272,7 +1267,7 @@
 	http->al.icp.opcode = ICP_INVALID;
 	http->al.url = http->uri;
 	debug(33, 9) ("httpRequestFree: al.url='%s'\n", http->al.url);
-	xmemcpy(&http->al.cache.out_ip, &request->out_ip, sizeof(struct sockaddr_storage));
+	http->al.cache.out_ip = request->out_ip;
 	if (http->reply && http->log_type != LOG_TCP_DENIED) {
 	    http->al.http.code = http->reply->sline.status;
 	    http->al.http.content_type = strBuf(http->reply->content_type);
@@ -1280,8 +1275,7 @@
 	    http->al.http.code = mem->reply->sline.status;
 	    http->al.http.content_type = strBuf(mem->reply->content_type);
 	}
-	xmemcpy(&http->al.cache.caddr, &conn->log_addr,
-		sizeof(struct sockaddr_storage));
+	http->al.cache.caddr = conn->log_addr;
 	http->al.cache.size = http->out.size;
 	http->al.cache.code = http->log_type;
 	http->al.cache.msec = tvSubMsec(http->start, current_time);
@@ -1323,7 +1317,7 @@
 	    http->al.reply = http->reply;
 	    accessLogLog(&http->al, http->acl_checklist);
 	    clientUpdateCounters(http);
-	    clientdbUpdate((struct sockaddr*)&conn->peer, http->log_type, PROTO_HTTP, http->out.size);
+	    clientdbUpdate(conn->peer.sin_addr, http->log_type, PROTO_HTTP, http->out.size);
 	}
     }
     if (http->acl_checklist)
@@ -1378,7 +1372,7 @@
     clientHttpRequest *http;
     debug(33, 3) ("connStateFree: FD %d\n", fd);
     assert(connState != NULL);
-    clientdbEstablished((struct sockaddr*)&connState->peer, -1);	/* decrement */
+    clientdbEstablished(connState->peer.sin_addr, -1);	/* decrement */
     n = connState->reqs.head;
     while (n != NULL) {
 	http = n->data;
@@ -1536,11 +1530,11 @@
     }
 #if USE_USERAGENT_LOG
     if ((str = httpHeaderGetStr(req_hdr, HDR_USER_AGENT)))
-	logUserAgent(fqdnFromAddr(&http->conn->log_addr), str);
+	logUserAgent(fqdnFromAddr(http->conn->log_addr), str);
 #endif
 #if USE_REFERER_LOG
     if ((str = httpHeaderGetStr(req_hdr, HDR_REFERER)))
-	logReferer(fqdnFromAddr(&http->conn->log_addr), str, rfc1738_escape_unescaped(http->uri));
+	logReferer(fqdnFromAddr(http->conn->log_addr), str, rfc1738_escape_unescaped(http->uri));
 #endif
 #if FORW_VIA_DB
     if (httpHeaderHas(req_hdr, HDR_X_FORWARDED_FOR)) {
@@ -3019,7 +3013,7 @@
 #if SIZEOF_SQUID_OFF_T <= 4
     if (http->out.size > 0x7FFF0000) {
 	debug(33, 1) ("WARNING: closing FD %d to prevent counter overflow\n", fd);
-	debug(33, 1) ("\tclient %s\n", sockaddr_ntoa(&http->conn->peer));
+	debug(33, 1) ("\tclient %s\n", inet_ntoa(http->conn->peer.sin_addr));
 	debug(33, 1) ("\treceived %d bytes\n", (int) http->out.size);
 	debug(33, 1) ("\tURI %s\n", http->log_uri);
 	comm_close(fd);
@@ -3028,7 +3022,7 @@
 #if SIZEOF_SQUID_OFF_T <= 4
     if (http->out.offset > 0x7FFF0000) {
 	debug(33, 1) ("WARNING: closing FD %d to prevent counter overflow\n", fd);
-	debug(33, 1) ("\tclient %s\n", sockaddr_ntoa(&http->conn->peer));
+	debug(33, 1) ("\tclient %s\n", inet_ntoa(http->conn->peer.sin_addr));
 	debug(33, 1) ("\treceived %d bytes (offset %d)\n", (int) http->out.size,
 	    (int) http->out.offset);
 	debug(33, 1) ("\tURI %s\n", http->log_uri);
@@ -3537,13 +3531,10 @@
 	http->flags.accel = 1;
 	debug(33, 5) ("INTERNAL REWRITE: '%s'\n", http->uri);
     } else if (*url == '/' && conn->port->transparent) {
-	char *q = NULL;
 	int port = 0;
 	const char *host = mime_get_header(req_hdr, "Host");
 	char *portstr;
-	if (!(q = strchr(host, ']')))
-	    q = host;
-	if (host && (portstr = strchr(q, ':')) != NULL) {
+	if (host && (portstr = strchr(host, ':')) != NULL) {
 	    *portstr++ = '\0';
 	    port = atoi(portstr);
 	}
@@ -3563,11 +3554,9 @@
 	if (conn->port->transparent && clientNatLookup(conn) == 0)
 	    conn->transparent = 1;
 	if (!host && conn->transparent) {
-		port = (conn->me.ss_family == AF_INET6) ? 
-			ntohs(((struct sockaddr_in6 *)&conn->me)->sin6_port) :
-			ntohs(((struct sockaddr_in *)&conn->me)->sin_port);
+	    port = ntohs(conn->me.sin_port);
 	    if (!host)
-		host = sockaddr_ntoa(&conn->me);
+		host = inet_ntoa(conn->me.sin_addr);
 	}
 	if (host) {
 	    size_t url_sz = 10 + strlen(host) + 6 + strlen(url) + 32 + Config.appendDomainLen;
@@ -3599,13 +3588,9 @@
 	if (*url != '/') {
 	    /* Fully qualified URL. Nothing special to do */
 	} else if (vhost && (t = mime_get_header(req_hdr, "Host"))) {
-	    char *portstr, *q; 
+	    char *portstr = strchr(t, ':');
 	    int port = 0;
 	    size_t url_sz = strlen(url) + 32 + Config.appendDomainLen + strlen(t);
-	    
-	    if (!(q = strchr(t, ']')))
-		q = t;
-	    portstr = strchr(q, ':');
 	    if (portstr) {
 		*portstr++ = '\0';
 		port = atoi(portstr);
@@ -3634,7 +3619,7 @@
 	    http->uri = xcalloc(url_sz, 1);
 	    snprintf(http->uri, url_sz, "%s://%s:%d%s",
 		http->conn->port->protocol,
-		sockaddr_ntoa(&http->conn->me),
+		inet_ntoa(http->conn->me.sin_addr),
 		vport, url);
 	    debug(33, 5) ("VPORT REWRITE: '%s'\n", http->uri);
 	} else if (internalCheck(url)) {
@@ -3743,7 +3728,7 @@
 	if (parser_return_code < 0) {
 	    debug(33, 1) ("clientReadRequest: FD %d (%s:%d) Invalid Request\n", fd, fd_table[fd].ipaddr, fd_table[fd].remote_port);
 	    err = errorCon(ERR_INVALID_REQ, HTTP_BAD_REQUEST, NULL);
-            xmemcpy(&err->src_addr, &conn->peer, sizeof(struct sockaddr_storage));
+	    err->src_addr = conn->peer.sin_addr;
 	    err->request_hdrs = xstrdup(conn->in.buf);
 	    http->log_type = LOG_TCP_DENIED;
 	    http->entry = clientCreateStoreEntry(http, method, null_request_flags);
@@ -3753,7 +3738,7 @@
 	if ((request = urlParse(method, http->uri)) == NULL) {
 	    debug(33, 5) ("Invalid URL: %s\n", http->uri);
 	    err = errorCon(ERR_INVALID_URL, HTTP_BAD_REQUEST, NULL);
-	    xmemcpy(&err->src_addr, &conn->peer, sizeof(struct sockaddr_storage));
+	    err->src_addr = conn->peer.sin_addr;
 	    err->url = xstrdup(http->uri);
 	    http->al.http.code = err->http_status;
 	    http->log_type = LOG_TCP_DENIED;
@@ -3809,20 +3794,13 @@
 	request->content_length = httpHeaderGetSize(&request->header,
 	    HDR_CONTENT_LENGTH);
 	request->flags.internal = http->flags.internal;
-        xmemcpy(&request->client_addr, &conn->peer, sizeof(struct sockaddr_storage));
-        request->client_port = (conn->peer.ss_family == AF_INET6) ?
-                      ntohs(((struct sockaddr_in6 *)&conn->peer)->sin6_port) :
-                      ntohs(((struct sockaddr_in *)&conn->peer)->sin_port);
+	request->client_addr = conn->peer.sin_addr;
+	request->client_port = ntohs(conn->peer.sin_port);
 #if FOLLOW_X_FORWARDED_FOR
 	request->indirect_client_addr = request->client_addr;
 #endif /* FOLLOW_X_FORWARDED_FOR */
-          xmemcpy(&request->my_addr, &conn->me, sizeof(struct sockaddr_storage));
-          request->my_port = (conn->me.ss_family == AF_INET6) ?
-                      ntohs(((struct sockaddr_in6 *)&conn->me)->sin6_port) :
-                      ntohs(((struct sockaddr_in *)&conn->me)->sin_port);
-          request->client_port = (conn->peer.ss_family == AF_INET6) ?
-                      ntohs(((struct sockaddr_in6 *)&conn->peer)->sin6_port) :
-                      ntohs(((struct sockaddr_in *)&conn->peer)->sin_port);
+	request->my_addr = conn->me.sin_addr;
+	request->my_port = ntohs(conn->me.sin_port);
 	request->http_ver = http->http_ver;
 	if (!urlCheckRequest(request) ||
 	    httpHeaderHas(&request->header, HDR_TRANSFER_ENCODING)) {
@@ -3867,7 +3845,7 @@
 	    if (!DLINK_ISEMPTY(conn->reqs) && DLINK_HEAD(conn->reqs) == http)
 		clientCheckFollowXForwardedFor(http);
 	    else {
-		debug(33, 1)("WARNING: pipelined CONNECT request seen from %s\n", sockaddr_ntoa(&http->conn->peer));
+		debug(33, 1) ("WARNING: pipelined CONNECT request seen from %s\n", inet_ntoa(http->conn->peer.sin_addr));
 		debugObj(33, 1, "Previous request:\n", ((clientHttpRequest *) DLINK_HEAD(conn->reqs))->request,
 		    (ObjPackMethod) & httpRequestPackDebug);
 		debugObj(33, 1, "This request:\n", request, (ObjPackMethod) & httpRequestPackDebug);
@@ -3888,7 +3866,7 @@
 	    debug(33, 1) ("Config 'request_header_max_size'= %ld bytes.\n",
 		(long int) Config.maxRequestHeaderSize);
 	    err = errorCon(ERR_TOO_BIG, HTTP_REQUEST_ENTITY_TOO_LARGE, NULL);
-            xmemcpy(&err->src_addr, &conn->peer, sizeof(struct sockaddr_storage));
+	    err->src_addr = conn->peer.sin_addr;
 	    http = parseHttpRequestAbort(conn, "error:request-too-large");
 	    /* add to the client request queue */
 	    dlinkAddTail(http, &http->node, &conn->reqs);
@@ -4194,7 +4172,8 @@
 {
     clientHttpRequest *http = data;
     ConnStateData *conn = http->conn;
-    debug(33, 1) ("WARNING: Closing client %s connection due to lifetime timeout\n", sockaddr_ntoa(&conn->peer));
+    debug(33, 1) ("WARNING: Closing client %s connection due to lifetime timeout\n",
+	inet_ntoa(conn->peer.sin_addr));
     debug(33, 1) ("\t%s\n", http->uri);
     comm_close(fd);
 }
@@ -4304,7 +4283,7 @@
 clientNatLookup(ConnStateData * conn)
 {
     socklen_t sock_sz = sizeof(conn->me);
-    struct in_addr orig_addr = ((struct sockaddr_in *)&conn->me)->sin_addr;
+    struct in_addr orig_addr = conn->me.sin_addr;
     static time_t last_reported = 0;
     /* If the call fails the address structure will be unchanged */
     if (getsockopt(conn->fd, SOL_IP, SO_ORIGINAL_DST, &conn->me, &sock_sz) != 0) {
@@ -4314,8 +4293,8 @@
 	}
 	return -1;
     }
-    debug(33, 5) ("clientNatLookup: addr = %s", sockaddr_ntoa(&conn->me));
-    if (orig_addr.s_addr != ((struct sockaddr_in *)&conn->me)->sin_addr.s_addr)
+    debug(33, 5) ("clientNatLookup: addr = %s", inet_ntoa(conn->me.sin_addr));
+    if (orig_addr.s_addr != conn->me.sin_addr.s_addr)
 	return 0;
     else
 	return -1;
@@ -4386,17 +4365,17 @@
     int fd = -1;
     fde *F;
     ConnStateData *connState = NULL;
-    struct sockaddr_storage peer;
-    struct sockaddr_storage me;
+    struct sockaddr_in peer;
+    struct sockaddr_in me;
     int max = INCOMING_HTTP_MAX;
 #if USE_IDENT
     static aclCheck_t identChecklist;
 #endif
     commSetSelect(sock, COMM_SELECT_READ, httpAccept, data, 0);
     while (max-- && !httpAcceptDefer(sock, NULL)) {
-	memset(&peer, '\0', sizeof(struct sockaddr_storage));
-	memset(&me, '\0', sizeof(struct sockaddr_storage));
-	if ((fd = comm_accept(sock, (struct sockaddr*)&peer, (struct sockaddr*)&me)) < 0) {
+	memset(&peer, '\0', sizeof(struct sockaddr_in));
+	memset(&me, '\0', sizeof(struct sockaddr_in));
+	if ((fd = comm_accept(sock, &peer, &me)) < 0) {
 	    if (!ignoreErrno(errno))
 		debug(50, 1) ("httpAccept: FD %d: accept failure: %s\n",
 		    sock, xstrerror());
@@ -4408,36 +4387,27 @@
 	connState = cbdataAlloc(ConnStateData);
 	connState->port = s;
 	cbdataLock(connState->port);
-	xmemcpy(&connState->peer, &peer,
-		sizeof(struct sockaddr_storage));
-	xmemcpy(&connState->log_addr, &peer,
-		sizeof(struct sockaddr_storage));
-/*
+	connState->peer = peer;
+	connState->log_addr = peer.sin_addr;
 	connState->log_addr.s_addr &= Config.Addrs.client_netmask.s_addr;
-*/
-	xmemcpy(&connState->me, &me,
-		sizeof(struct sockaddr_storage));
+	connState->me = me;
 	connState->fd = fd;
 	connState->pinning.fd = -1;
 	connState->in.buf = memAllocBuf(CLIENT_REQ_BUF_SZ, &connState->in.size);
 	comm_add_close_handler(fd, connStateFree, connState);
 	if (Config.onoff.log_fqdn)
-	    fqdncache_gethostbyaddr(&peer, FQDN_LOOKUP_IF_MISS);
+	    fqdncache_gethostbyaddr(peer.sin_addr, FQDN_LOOKUP_IF_MISS);
 	commSetTimeout(fd, Config.Timeout.request, requestTimeout, connState);
 #if USE_IDENT
-	xmemcpy(&identChecklist.src_addr, &peer,
-		sizeof(struct sockaddr_storage));
-	xmemcpy(&identChecklist.my_addr, &me,
-		sizeof(struct sockaddr_storage));
-	identChecklist.my_port = (me.ss_family == AF_INET6) ? 
-		ntohs(((struct sockaddr_in6 *)&me)->sin6_port) :
-		ntohs(((struct sockaddr_in *)&me)->sin_port) ;
+	identChecklist.src_addr = peer.sin_addr;
+	identChecklist.my_addr = me.sin_addr;
+	identChecklist.my_port = ntohs(me.sin_port);
 	if (aclCheckFast(Config.accessList.identLookup, &identChecklist))
 	    identStart(&me, &peer, clientIdentDone, connState);
 #endif
 	commSetSelect(fd, COMM_SELECT_READ, clientReadRequest, connState, 0);
 	commSetDefer(fd, clientReadDefer, connState);
-	clientdbEstablished(&peer, 1);
+	clientdbEstablished(peer.sin_addr, 1);
 	incoming_sockets_accepted++;
     }
 }
@@ -4555,8 +4525,8 @@
     https_port_list *s = data;
     int fd = -1;
     ConnStateData *connState = NULL;
-    struct sockaddr_storage peer;
-    struct sockaddr_storage me;
+    struct sockaddr_in peer;
+    struct sockaddr_in me;
     int max = INCOMING_HTTP_MAX;
 #if USE_IDENT
     static aclCheck_t identChecklist;
@@ -4564,8 +4534,8 @@
     commSetSelect(sock, COMM_SELECT_READ, httpsAccept, s, 0);
     while (max-- && !httpAcceptDefer(sock, NULL)) {
 	fde *F;
-	memset(&peer, '\0', sizeof(struct sockaddr_storage));
-	memset(&me, '\0', sizeof(struct sockaddr_storage));
+	memset(&peer, '\0', sizeof(struct sockaddr_in));
+	memset(&me, '\0', sizeof(struct sockaddr_in));
 	if ((fd = comm_accept(sock, &peer, &me)) < 0) {
 	    if (!ignoreErrno(errno))
 		debug(50, 1) ("httpsAccept: FD %d: accept failure: %s\n",
@@ -4577,34 +4547,25 @@
 	connState = cbdataAlloc(ConnStateData);
 	connState->port = (http_port_list *) s;
 	cbdataLock(connState->port);
-	xmemcpy(&connState->peer, &peer,
-	    sizeof(struct sockaddr_storage));
-	xmemcpy(&connState->log_addr, &peer,
-	    sizeof(struct sockaddr_storage));
-/*
+	connState->peer = peer;
+	connState->log_addr = peer.sin_addr;
 	connState->log_addr.s_addr &= Config.Addrs.client_netmask.s_addr;
-*/
-	xmemcpy(&connState->me, &me,
-	    sizeof(struct sockaddr_storage));
+	connState->me = me;
 	connState->fd = fd;
 	connState->pinning.fd = -1;
 	connState->in.buf = memAllocBuf(CLIENT_REQ_BUF_SZ, &connState->in.size);
 	comm_add_close_handler(fd, connStateFree, connState);
 	if (Config.onoff.log_fqdn)
-	    fqdncache_gethostbyaddr(&peer, FQDN_LOOKUP_IF_MISS);
+	    fqdncache_gethostbyaddr(peer.sin_addr, FQDN_LOOKUP_IF_MISS);
 	commSetTimeout(fd, Config.Timeout.request, requestTimeout, connState);
 #if USE_IDENT
-	xmemcpy(&identChecklist.src_addr, &peer,
-		sizeof(struct sockaddr_storage));
-	xmemcpy(&identChecklist.my_addr, &me,
-		sizeof(struct sockaddr_storage));
-/*
+	identChecklist.src_addr = peer.sin_addr;
+	identChecklist.my_addr = me.sin_addr;
 	identChecklist.my_port = ntohs(me.sin_port);
-*/
 	if (aclCheckFast(Config.accessList.identLookup, &identChecklist))
 	    identStart(&me, &peer, clientIdentDone, connState);
 #endif
-	clientdbEstablished(&peer, 1);
+	clientdbEstablished(peer.sin_addr, 1);
 	incoming_sockets_accepted++;
 	httpsAcceptSSL(connState, s->sslContext);
     }
@@ -4742,7 +4703,6 @@
 {
     http_port_list *s;
     int fd;
-    char host[100], port[8];
     for (s = Config.Sockaddr.http; s; s = s->next) {
 	if (MAXHTTPPORTS == NHttpSockets) {
 	    debug(1, 1) ("WARNING: You have too many 'http_port' lines.\n");
@@ -4750,10 +4710,12 @@
 	    continue;
 	}
 	enter_suid();
-        fd = comm_open(SOCK_STREAM, IPPROTO_TCP,
-            (struct sockaddr *)&s->s,
-            COMM_NONBLOCKING,
-            "HTTP Socket");
+	fd = comm_open(SOCK_STREAM,
+	    IPPROTO_TCP,
+	    s->s.sin_addr,
+	    ntohs(s->s.sin_port),
+	    COMM_NONBLOCKING,
+	    "HTTP Socket");
 	leave_suid();
 	if (fd < 0)
 	    continue;
@@ -4764,14 +4726,12 @@
 	 * peg the CPU with select() when we hit the FD limit.
 	 */
 	commSetDefer(fd, httpAcceptDefer, NULL);
-	getnameinfo((struct sockaddr*)&s->s, SOCKLEN(&s->s),
-	    host, 100, port, 8, NI_NUMERICHOST|NI_NUMERICSERV);
-	debug(1, 1) ("Accepting %s HTTP connections at %s, port %s, FD %d.\n",
+	debug(1, 1) ("Accepting %s HTTP connections at %s, port %d, FD %d.\n",
 	    s->transparent ? "transparently proxied" :
 	    s->accel ? "accelerated" :
 	    "proxy",
-	    host,
-	    port,
+	    inet_ntoa(s->s.sin_addr),
+	    (int) ntohs(s->s.sin_port),
 	    fd);
 	HttpSockets[NHttpSockets++] = fd;
     }
@@ -4794,7 +4754,8 @@
 	enter_suid();
 	fd = comm_open(SOCK_STREAM,
 	    IPPROTO_TCP,
-	    &s->http.s,
+	    s->http.s.sin_addr,
+	    ntohs(s->http.s.sin_port),
 	    COMM_NONBLOCKING,
 	    "HTTPS Socket");
 	leave_suid();
@@ -4804,10 +4765,8 @@
 	commSetSelect(fd, COMM_SELECT_READ, httpsAccept, s, 0);
 	commSetDefer(fd, httpAcceptDefer, NULL);
 	debug(1, 1) ("Accepting HTTPS connections at %s, port %d, FD %d.\n",
-	    sockaddr_ntoa(&s->http.s),
-	    (int) s->http.s.ss_family == AF_INET6 ? 
-		ntohs(((struct sockaddr_in6 *)&s->http.s)->sin6_port) :
-		ntohs(((struct sockaddr_in *)&s->http.s)->sin_port) ,
+	    inet_ntoa(s->http.s.sin_addr),
+	    (int) ntohs(s->http.s.sin_port),
 	    fd);
 	HttpSockets[NHttpSockets++] = fd;
     }
